<?php
/**
* @name MOOJ Proforms 
* @version 1.0
* @package proforms
* @copyright Copyright (C) 2008-2010 Mad4Media. All rights reserved.
* @author Dipl. Inf.(FH) Fahrettin Kutyol
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Please note that some Javascript files are not under GNU/GPL License.
* These files are under the mad4media license
* They may edited and used infinitely but may not repuplished or redistributed.  
* For more information read the header notice of the js files.
**/
	
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );    
define('M4J_NOBAR',0);	
    
$buildCompatibility = M4J_BACKUP_COMPAT;

remember_cid();
	
$export= JRequest::getInt("export",0);
$import= JRequest::getInt("import",0);

$message = (isset($_REQUEST["success"])) ? M4J_LANG_BACKUP_SUCCESS : null;
	
$db = & JFactory::getDBO();
	
$error = "";	
$sql = "";

if($import){
	jimport('joomla.filesystem.file');
	jimport('joomla.filesystem.folder');
	
	$file = JRequest::getVar('sql_file', null, 'files', 'array');
 	if($file){
		$filename = JFile::makeSafe($file['name']);
		$hash = md5($filename). ".pfm";
		$src = $file['tmp_name'];
		$dest = JPATH_ROOT . DS . "tmp" . DS . $hash;
	 
		//First check if the file has the right extension, we need sql only
		if ( strtolower(JFile::getExt($filename) ) == 'sql') {
		   if ( JFile::upload($src, $dest) ) {
		    $sql = file_get_contents($dest); 	
		    JFile::delete($dest);
		   	$regex = '/SYSTEMINFO(.*?)SYSTEMINFOEND/';
		   	preg_match_all( $regex, $sql, $matches );
		   	if(isset($matches[1][0])){
		   		$systemInfo = explode("|", $matches[1][0]);
		   		if(sizeof($systemInfo) == 3){
		   			$version = trim( $systemInfo[0] );
		   			$build = (int) $systemInfo[1];
		   			$type = trim( $systemInfo[2] );
		   			
		   			$isBuildCompatible = ( $build >= $buildCompatibility ) && ( intval(M4J_BUILD) >= $build );
		   			if($type != "PRO" ) $error .= M4J_LANG_BACKUPERROR_1;
		   			if(! $isBuildCompatible ) $error .= sprintf(M4J_LANG_BACKUPERROR_2, M4J_BUILD);
		   			
		   			if($type == "PRO" && $isBuildCompatible){
		   				// DATABASE RESTORE			  
					    $db->setQuery($sql);  
					   	$result = $db->queryBatch();
					   	if($result === false){
					   		$error = M4J_LANG_BACKUPERROR_6;
					   	}else{
					   		m4jRedirect(M4J_BACKUP.M4J_REMEMBER_CID_QUERY."&success=1");	
					   	}
		   			}
		   			
		   		}else{
		   			$error = M4J_LANG_BACKUPERROR_3;	
		   		}
		   	}else{
		   		$error = M4J_LANG_BACKUPERROR_3;
		   	}
		   	
		   	
		   }else {
		      $error = M4J_LANG_BACKUPERROR_4;
		   }
		} else {
		   $error = M4J_LANG_BACKUPERROR_5;
		}
	
 	}
	
	
}



if($export){
	
	$no_storage = JRequest::getInt("no_storage", 0);
	$no_apps = JRequest::getInt("no_apps", 0);
	$no_config = JRequest::getInt("no_config", 0);
	
	$noStorageTables = array("#__m4j_storage", "#__m4j_storage_items");
	$noAppsTables = array("#__m4j_apps2jobs", "#__m4j_apps");
	$optionTables = array_merge($noStorageTables, $noAppsTables);
	array_push($optionTables, "#__m4j_config");
	
	
	$date = date("Y.m.d H:i:s");
	$version = M4J_VERSION_NO . " Build: ".M4J_BUILD;
	$sysInfo = M4J_VERSION_NO."|".$buildCompatibility."|PRO";
	$sql = "-- Mooj Proforms SQL Dump\n";
	$sql .= "-- Creation Date: $date \n";
	$sql .= "-- For Version: $version \n";
	$sql .= "-- Backup compatibile with build: $buildCompatibility \n";
	$sql .= "-- SYSTEMINFO $sysInfo SYSTEMINFOEND  \n\n\n";
	$sql .= "SET SQL_MODE=\"NO_AUTO_VALUE_ON_ZERO\";  \n\n\n";
	
	$jConfig = new JConfig();
	$prefix = $jConfig->dbprefix;
	$prefixLength = strlen($prefix);
	$m4jPrefix = $prefix."m4j_";
	
	$db->setQuery("SHOW TABLES");
	$tableList = $db->loadRowList();
	$tables = array();
	foreach($tableList as $table){
		if(strpos($table[0], $prefix."m4j_") !== false){
			$withDummy =  substr_replace($table[0], "#__", 0, $prefixLength);
			
			$dontAdd = ($no_storage && in_array($withDummy, $noStorageTables) ) || 
					   ($no_apps && in_array($withDummy, $noAppsTables) ) || 
					   ($no_apps && ( strpos($withDummy, "m4j_apps") !== false ) ) || 
					   ($no_config && $withDummy == "#__m4j_config") ;
			
			if(!$dontAdd){
				array_push($tables, $withDummy);
			}			
		}
	}
	
	foreach($tables as $table){
			
		$sql.= "DROP TABLE IF EXISTS `".$table."`;\n";
		$db->setQuery("SHOW CREATE TABLE `".$table."` ");
		$createTable = $db->loadRow();
		$sql .= str_replace(array("TYPE=MyISAM","TYPE=MRG_MYISAM","TYPE=BLACKHOLE","TYPE=CSV","TYPE=MEMORY","TYPE=ARCHIVE","TYPE=InnoDB","TYPE=PERFORMANCE_SCHEMA",
								  "ENGINE=MyISAM","ENGINE=MRG_MYISAM","ENGINE=BLACKHOLE","ENGINE=CSV","ENGINE=MEMORY","ENGINE=ARCHIVE","ENGINE=InnoDB","ENGINE=PERFORMANCE_SCHEMA"),"", str_replace($m4jPrefix, "#__m4j_", $createTable[1]) ). ";\n\n";	

		$insertQuery = "INSERT INTO `".$table."` (#COLUMNS#) VALUES\n";
		
		$columnArray = array();
		$db->setQuery("SHOW COLUMNS FROM `".$table."` ");
		$columns = $db->loadRowList();
		if($columns){
			foreach($columns as $column){
				array_push($columnArray, "`". $column[0]."`");
			}
		}
		$insertQuery = str_replace("#COLUMNS#", implode(",", $columnArray), $insertQuery);
		
		$db->setQuery("SELECT * FROM `".$table."` ");
		$rows = $db->loadRowList();
		if($rows){
			$sql .= $insertQuery;
			$rowsArray = array();
			foreach($rows as $row){
				$valuesArray = array();
				foreach($row as $key=>$value){
					$value = str_replace("'", "''", $value);
					$value = str_replace("\n", "\\n", $value);
					$value = str_replace("\r", "\\r", $value);
					array_push($valuesArray,"'".$value."'");
				}
				array_push($rowsArray, "(" . implode(",",$valuesArray) . ")" );
			}
			$sql .= implode(",\n", $rowsArray) .";\n\n\n";
		}
		
		
	}//Foreach Tables
	
		header("Content-Type: application/force-download");	
		header("Content-Disposition: attachment; filename=\"proforms_db_backup_".$date.".sql\"");
		echo $sql;
		exit();	
}//EOF EXPORT
	
// Display config	  
HTML_m4j::head(M4J_BACKUP);
//    HTML_m4j::configuration(M4J_LANG_CONFIG,$helpers->config_feedback($advice));
 	$args = array("heading"=>M4J_LANG_BACKUP, "error"=>$error , "sql"=>$sql, "message" => $message);
 	echo MTemplater::get(M4J_TEMPLATES."backup.php",$args);
HTML_m4j::footer();

?>
