// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// @license: Mad4Media Javascipt License - copyright Mad4Media - Fahrettin Kutyol - All rights reserved    ++
// (re-) publishing or forking for any purpose of commercial or non-commercial use is not allowed.		   ++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

var recordCount = 0;

function startSending(){
	var error = "";
	var fromName = dojo.byId("fromname").value;
	var fromMail = dojo.byId("from").value;
	var subject = dojo.byId("subject").value;
	var filter = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,6})$/;		
	
	if(!fromName){
		error += mailText.NOFROMNAME+"\n";
	}
	
	if(!fromMail){
		error += mailText.NOFROM+"\n";
	}
	
	if(!filter.test(fromMail) && fromMail.length != 0 ){
		error += mailText.NOVALIDEMAIL+"\n";		
	}
	
	if(!subject){
		error += mailText.NOSUBJECT;
	}
	
	
	
	if(error){
		alert(error);
		return;
	}
	
	if(isAliases) toggleAliases();
	
	dojo.byId("storageCount").innerHTML = '<img src="'+M4J_IMAGES+'loading.gif" class="m4jLoadingImage" align="top"/>';
	dojo.byId("m4jSendingInfo").innerHTML = '';
	
	dojo.style("mailSendingEnd",{display: "none"} );
	dojo.style("sendingPanel",{display: "block", opacity: 0});
	dojo.style("closeSendingButton",{display: "none"});
	dojo.style("startSending",{display: "none"});
	dojo.style("cancelMail",{display: "block", opacity: 0});
	dojo.fadeIn({
		node: "sendingPanel"
	}).play();
	dojo.fadeIn({
		node: "cancelMail"
	}).play();
	
	
	dojo.xhrGet({
	    url: XHRMAILCOUNT,
	    handleAs : "json",
	    form: "m4jMailForm",
	    preventCache: true,
	    load: dojo.hitch(this,function(data){
	    	console.log("JSON from count xhr:");
	    	console.log(data);
	    	recordCount = data.count;
	    	dojo.byId("storageCount").innerHTML = data.count;
	    	dojo.byId("totalcount").value =  data.count;
	    	//Next step sending chunks
	    	promail.init();
	    })
	});
}





function cancelSending(){
	promail.cancel();
	dojo.byId("iframeWrap").innerHTML = '<span class="mailingCanceled">' + mailText.SENDING_CANCELED + '</span>';
	dojo.style("startSending",{display: "block", opacity: 0});
	dojo.style("mailSendingEnd",{display: "block", color: "red", opacity: 0 } );
	dojo.byId("mailSendingEnd").innerHTML = mailText.SENDING_CANCELED;
	dojo.fadeIn({
		node: "mailSendingEnd"
	}).play();
	hideCancelButton();		
	showCloseButton();
}

function hideCancelButton(){
	dojo.fadeOut({
		node: "cancelMail",
		onEnd: function(){
			dojo.style("cancelMail",{display: "none"});
		}
	}).play();
}

function showCloseButton(){
	dojo.style("closeSendingButton",{display: "block", opacity:0});
	dojo.fadeIn({
		node: "closeSendingButton"
	}).play();
}

function closeSending(){
	dojo.byId("iframeWrap").innerHTML = "";
	dojo.byId("progress").innerHTML = "0";
	dojo.style("startSending",{display: "block", opacity: 0});
	dojo.fadeOut({
		node: "sendingPanel",
		onEnd: function(){
			dojo.style("sendingPanel",{display: "none"});
			dojo.fadeIn({
				node: "startSending"
			}).play();
		}
	}).play();
}




function toggleMailEditor(){
	var isHTMLMail = dojo.byId("checkbox_html_mail").value;
	if(isHTMLMail == 1){
		dojo.style("bodyHTML",{display:"block"});
		dojo.style("bodyNoHTML",{display:"none"});
	}else{
		dojo.style("bodyHTML",{display:"none"});
		dojo.style("bodyNoHTML",{display:"block"});		
	}
}


function showSaveToTemplate(){
	loadTemplateList();
	dojo.style("saveToTemplate",{display: "block", opacity: 0});
	dojo.fadeIn({
		node: "saveToTemplate"
	}).play();
}

function closeSaveToTemplate(){
	dojo.fadeOut({
		node: "saveToTemplate",
		onEnd: function(){
			dojo.style("saveToTemplate",{display: "none"});
		}
	}).play();
}

function showGetFromTemplate(){
	loadTemplateList(1);
	dojo.style("getFromTemplate",{display: "block", opacity: 0});
	dojo.fadeIn({
		node: "getFromTemplate"
	}).play();
}

function closeGetFromTemplate(){
	dojo.fadeOut({
		node: "getFromTemplate",
		onEnd: function(){
			dojo.style("getFromTemplate",{display: "none"});
		}
	}).play();
}



function templateSubmit(){
	var form = dojo.byId("m4jMailForm");
	form.action = selfURI;
	form.target = "_self";
	form.submit();	
}

function saveNewMailTemplate(){	
	dojo.byId("task").value="new";
	templateSubmit();
	return false;
}

function mtUpd(mtid){	
	dojo.byId("task").value="update";
	dojo.byId("mtid").value=mtid;
	templateSubmit();
}

function mtDelete(mtid){
	dojo.byId("task").value="delete";
	dojo.byId("mtid").value=mtid;
	templateSubmit();	
}

function mtGet(mtid){
	dojo.byId("task").value="get";
	dojo.byId("mtid").value=mtid;
	templateSubmit();	
}



function loadTemplateList(get){
	var mtURL = get ? mtListURI+"&getmt=1" : mtListURI ;
	var mtListNode = get ? "mtGetList" : "mtList" ;
	dojo.xhrGet({
	    url: mtURL,
	    preventCache: true,
	    load: dojo.hitch(this,function(data){
	        dojo.byId(mtListNode).innerHTML = data;
	    })
	});
}

var isAliases = 0;

function toggleAliases(){
	
	if(isAliases){
		isAliases = 0;
		dojo.style("mtAliasPlus",{display: "block"});
		dojo.style("mtAliasX",{display: "none"});
		
		dojo.fadeOut({
			node: "mailAliases",
			onEnd: function(){
				dojo.style("mailAliases",{display: "none"});
			}
		}).play();
	}else{

		 _LoadTo(XHRALIAS,"mailAliases");
		isAliases = 1;
		dojo.style("mtAliasPlus",{display: "none"});
		dojo.style("mtAliasX",{display: "block"});
		
		dojo.style("mailAliases",{display: "block", opacity: 0});
		dojo.fadeIn({
			node: "mailAliases"
		}).play();
		
	}
	
}


function addToMailEditor(text){
	var isHTML = dojo.byId("checkbox_html_mail").value;
	
	if(isHTML == 1){
		if(typeof IeCursorFix == 'function'){
			IeCursorFix();
		}
		jInsertEditorText(text,"body"); 
	}else{
		var area = dojo.byId("bodyNoHTML");
		var start = area.selectionStart;
		
		if(dojo.isIE){
			var c = "\001",
		    	sel = document.selection.createRange(),
		    	dul = sel.duplicate(),
		    	len = 0;

			dul.moveToElementText(area);
			sel.text = c;
			len = dul.text.indexOf(c);
			sel.moveStart('character',-1);
			sel.text = "";
			start =  len;

		}
		
		
		area.value= area.value.substr(0, start) + text + area.value.substr(start, area.value.length);		
	}	
	return false;
}

var promail = {
		isRunning: false,
		count: 0,
		chunks: 0,
		iframeWrap: null,
		chunkCount: 0,
		progressCount: 0,
		sceduleTime: 1000,
		startField: null,
		form: null,
		init: function(){
			if(this.isRunning) return false;
			this.isRunning = true;
			this.chunkCount = 0;
			
			this.iframeWrap = dojo.byId("iframeWrap");
			this.iframeWrap.innerHTML = "";
			dojo.byId("progress").innerHTML = "0";
			this.progressCount = 0;
			this.chunkCount = 0;
			this.sceduleTime = ( dojo.byId("time").value * 1000 );
			this.chunks = dojo.byId("chunks").value;
			this.startField = dojo.byId("start");
			this.form = dojo.byId("m4jMailForm");
			this.count = recordCount;
	        this.prepare();
		},
						
		addIFrame: function(start){
			this.startField.value = start;
			var iframeName = "mailChunk_"+start;
			var div = document.createElement("DIV");
			div.innerHTML = '<iframe frameborder="0" style="width:100%; height:100%;" src="" name="'+iframeName+'" scrolling="no" ></iframe>'+"\n";
			this.iframeWrap.appendChild(div);
			this.form.action = XHRMAILCHUNK; 
			this.form.target = iframeName; 
			this.form.submit();
		},		
		
		prepare: function(){
			this.chunkCount = Math.ceil(this.count / this.chunks);
			this.timer = setTimeout('promail.scedule(0)', 100 );
		},
		timer: null,
		cancel: function(){
			if(this.timer) {
				clearTimeout(this.timer);
				this.timer = null;
			}
			this.isRunning = false;
		},
		scedule: function(step){
				
			var start = step*this.chunks;
			this.addIFrame(start);
			
			console.log("STEP: "+step+" LIMIT "+start+","+this.chunks);
			
			step++;
			
			if(step < this.chunkCount){
				this.timer = setTimeout('promail.scedule('+step+')', this.sceduleTime );
			}else{
				this.cancel();
			}
		},
		progress: function(info){
			if(dojo.isObject(info)){
				var start = info.start || 0;
				var end = info.end || 0;
				var sent = info.sent || 0;
				var failed = info.failed || 0;
				var noaddress = info.noaddress || 0;

				var sendingInfo = dojo.byId("m4jSendingInfo");
				sendingInfo.innerHTML += mailText.SENDINGCHUNKS + ': ' + start + ' - ' + end +  ' | <span style="color: green;">' + 
					mailText.SENT + ': ' + sent + ' </span>';
				
				if(failed){	
					sendingInfo.innerHTML += ' |  <span style="color: red;"> ' + mailText.FAILED + ': ' + failed + ' => </span>' + noaddress + ' ' + 
					mailText.NOEMAILMATCH + "<br/>\n" ;
				}else{
					sendingInfo.innerHTML += "<br/>\n" ;
				}
			}
			this.progressCount++;
			var percent = Math.round(this.progressCount/this.chunkCount*100);
			dojo.byId("progress").innerHTML = percent;
			if(percent == 100) {
				dojo.style("mailSendingEnd",{display:"block", opacity: 0, color: "green"});
				dojo.byId("mailSendingEnd").innerHTML = mailText.SENDING_SUCCESS;
				dojo.fadeIn({
					node: "mailSendingEnd"
				}).play();
				hideCancelButton();
				showCloseButton();
			}
		}	
}



dojo.addOnLoad(function(){
	var storageSearch = parent.getStorageSearch();
	dojo.byId("searchBox").value = storageSearch.search;
	dojo.byId("searchIn").value = storageSearch.searchIn;
	dojo.byId("optInFilter").value = storageSearch.optInFilter;
	console.log("Storage Search Query:");
	console.log(storageSearch);
});



