// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// @license: Mad4Media Javascipt License - copyright Mad4Media - Fahrettin Kutyol - All rights reserved    ++
// (re-) publishing or forking for any purpose of commercial or non-commercial use is not allowed.		   ++
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


var m4jScrollConfirm = {
	fields: [],
	submitShows: 1,
	length: 0,
	init: function(){
		var self = m4jScrollConfirm;
		var fields =  dojo.query(".m4jScrollConfirm");
		
		fields.forEach(dojo.hitch(this,function(node){
			node.scrollTop = 0;
			node.bounds = dojo.coords(node);
			var isScroll = node.bounds.h - node.scrollHeight - dojo._getBorderExtents(node).h;
			if(isScroll){
				node.scrolledToEnd = 0;
				node.onscroll = function(el){m4jScrollConfirm.scrollPosition(this);};
				self.fields.push(node);
			}else{
				var hiColor = node.getAttribute("lang");
				if(hiColor) dojo.style(node,{borderColor: hiColor});
			}
		}));
		self.length = self.fields.length;
		if( self.length ){
			self.submitShows = 0;
			var wrap = dojo.byId("m4jSubmitWrap");
			wrap.oldDisplay = wrap.style.display;
			dojo.style(wrap,{display:"none"});
			m4jCancelSubmit = true;
		}
	},
	
	check: function(){
		if(this.submitShows) return false;
		var count = 0;
		var length = this.length;
		dojo.forEach(this.fields,dojo.hitch(this,function(node){
			if(node.scrolledToEnd) count++; 
		}));
		if(!(length - count)){
			var wrap = dojo.byId("m4jSubmitWrap");
			var displayValue = wrap.oldDisplay ? wrap.oldDisplay : "block";
			dojo.style(wrap,{display: displayValue, opacity: 0});
			dojo.anim(wrap,{opacity: 1});
			m4jCancelSubmit = false;
			this.submitShows = 1;
		}
	},
	
	scrollPosition: function(node){
		var bounds = node.bounds;
		var isEndMath = node.scrollHeight - bounds.h - node.scrollTop;
		if(isEndMath <= 0){
			var hiColor = node.getAttribute("lang");
			if(hiColor) dojo.style(node,{borderColor: hiColor});
			node.scrolledToEnd = 1;
			m4jScrollConfirm.check();
		}
		
	}
}



dojo.addOnLoad(m4jScrollConfirm.init);