<?php
/**
 * 			Mod Template Selector Helper
 * @version	 	1.1.0
 * @package		Template Selector
 * @copyright		Copyright (C) 2009 Joomler!.net. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 *
 * @author		Joomler!.net  joomlers@gmail.com
 * @link 			http://www.joomler.net/
 */

/**
* @package		Joomla
* @copyright		Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modTemplateSelector
{
	function getLists($params)
	{
		$mainframe = & JFactory::getApplication();

		if($mainframe->isAdmin()){
			return array();
		}

		require_once JPATH_SITE. DS. 'administrator'. DS. 'components'. DS. 'com_templates'. DS. 'helpers'. DS. 'template.php';

		$rows = TemplatesHelper::parseXMLTemplateFiles(JPATH_THEMES);
		if(count($rows) < 1){
			return array();
		}

		$lists = array();

		$listSelected = explode(',', $params->get('templates', ''));
		$selectedTemplates = (bool)(count($listSelected) > 0 && $listSelected[0] != '');

		$selected = $mainframe->getTemplate();
		$lists['current_image'] = JURI::base(true). '/templates/'. $selected. '/template_thumbnail.png';
		$options = array();
		if($selectedTemplates){
			foreach($rows as $row)  {
				if(in_array($row->directory, $listSelected) || $row->directory == $selected){
					$options[] = $row;
			}
		}
		} else {
			$options = $rows;
		}

		$mainframe = & JFactory::getApplication();

		$directory = $mainframe->getUserStateFromRequest('templateSelector', 'templatedirectory', '', 'cmd');
		if(!empty($directory)){
			$selected = $directory;
			$lists['current_image'] = JURI::base(true). '/templates/'. $directory. '/template_thumbnail.png';
		} else {
			$selected = $mainframe->getTemplate();
			$lists['current_image'] = JURI::base(true). '/templates/'. $selected. '/template_thumbnail.png';
		}

		$base = JURI::base(true). '/templates/';
		$javascript = "function tSelector(v){var tt=document.getElementById('tpscurimg');var t='/template_thumbnail.png';var b='$base';if(tt.src.indexOf('no_image')<0)tt.src=tt.src.replace(/templates\/.+?\//, 'templates/'+v+'/');else tt.src=b+v+t;document.getElementById('tmplSelectForm').templatedirectory.value=v;}";

		$doc = & JFactory::getDocument();
		$doc->addScriptDeclaration($javascript);

		$lists['list'] = JHTML::_('select.genericlist', $options, 'tmpldirectory', 'class="inputbox" onchange="tSelector(this.value);"', 'directory', 'name', $selected);
		$lists['selected'] = $selected;

		return $lists;
	}
}
